﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;

namespace demo
{
    public struct ST_Point
    {
        public float x;			/*	坐标, 雷达点云在设定识别区域中的坐标 */
        public float y;
    };

    class Program
    {
        [DllImport(@"..\\..\\bin\\x86\\ydlidar_driver.dll", EntryPoint = "EAIScreenLd_init", CharSet = CharSet.Ansi,
            ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]

        extern static IntPtr EAIScreenLd_init(string ulrSetting);

        [DllImport(@"..\\..\\bin\\x86\\ydlidar_driver.dll", EntryPoint = "EAIScreenLd_getLdMap", CharSet = CharSet.Ansi,
            ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]

        extern static int EAIScreenLd_getLdMap(IntPtr handle, ref ST_Point ptArr, ref int nPtArr);

        [DllImport(@"..\\..\\bin\\x86\\ydlidar_driver.dll", EntryPoint = "EAIScreenLd_destory", CharSet = CharSet.Ansi,
            ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]

        extern static int EAIScreenLd_destory(ref IntPtr hhandle);


        ////////////////////////////////////////////////////////////////////////////////////////////默认
        //                     G4雷达零点
        //                      |
        //                      |______

        //|-------960----------|////                ------
        //                //雷达安装位置//               |
        //                                             | 260
        //|----------------1920----------------------| |
        ////////////////////////////////////////////----
        // (0,0)                                  //  |
        //                                        //  |
        //                                        //  |
        //                                        //  |
        //                                        // 1080
        //                屏幕                    //  |
        //                                        //  |
        //                                        //  |
        //                                        //  |
        //                                        //  |
        ////////////////////////////////////////////-----


        static void Main(string[] args)
        {
            string ulrSetting = "..\\..\\bin\\x86\\setting.ini";
            IntPtr handle = EAIScreenLd_init(ulrSetting);

            ST_Point[] ptArr = new ST_Point[2048];
            int nPtArr = 0;

            while (true)
            {
                nPtArr = 2048;

                if (1 != EAIScreenLd_getLdMap(handle, ref ptArr[0], ref nPtArr))
                {
                    Console.Write("get lidar map error !!! \n");
                    break;
                }

                Console.Write("nPtArr : {0} \n", nPtArr);
                for (int i = 0; i < nPtArr; i++)
                {
                    Console.Write("{0:f1}, {0:f1}........", ptArr[i].x, ptArr[i].y);
                }
                Console.Write("\n\n\n");
            }

            EAIScreenLd_destory(ref handle);//退出
        }
    }
}










